# coding: utf-8

# flake8: noqa

"""
    UbiOps

    Client Library to interact with the UbiOps API.  # noqa: E501

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

__version__ = "3.16.1"

# import CoreApi
from ubiops.api.core_api import CoreApi

# import Training
from ubiops.training.training import Training
from ubiops.training.experiment_create import ExperimentCreate
from ubiops.training.experiment_detail import ExperimentDetail
from ubiops.training.experiment_list import ExperimentList
from ubiops.training.experiment_update import ExperimentUpdate
from ubiops.training.experiment_run_create import ExperimentRunCreate
from ubiops.training.experiment_run_create_response import ExperimentRunCreateResponse
from ubiops.training.experiment_run_detail import ExperimentRunDetail
from ubiops.training.experiment_run_list import ExperimentRunList
from ubiops.training.experiment_run_update import ExperimentRunUpdate
from ubiops.training.experiment_run_update_response import ExperimentRunUpdateResponse

# import ApiClient
from ubiops.api_client import ApiClient
from ubiops.configuration import Configuration
from ubiops.exceptions import UbiOpsException, OpenApiException, ApiTypeError, ApiValueError, ApiKeyError, ApiException

# import models into sdk package
from ubiops.models.attachment_fields_list import AttachmentFieldsList
from ubiops.models.attachment_sources_list import AttachmentSourcesList
from ubiops.models.attachments_create import AttachmentsCreate
from ubiops.models.attachments_list import AttachmentsList
from ubiops.models.audit_list import AuditList
from ubiops.models.blob_list import BlobList
from ubiops.models.bucket_create import BucketCreate
from ubiops.models.bucket_detail import BucketDetail
from ubiops.models.bucket_list import BucketList
from ubiops.models.bucket_update import BucketUpdate
from ubiops.models.build_list import BuildList
from ubiops.models.deployment_create import DeploymentCreate
from ubiops.models.deployment_create_response import DeploymentCreateResponse
from ubiops.models.deployment_detail import DeploymentDetail
from ubiops.models.deployment_input_field_create import DeploymentInputFieldCreate
from ubiops.models.deployment_instance_type import DeploymentInstanceType
from ubiops.models.deployment_list import DeploymentList
from ubiops.models.deployment_output_field_create import DeploymentOutputFieldCreate
from ubiops.models.deployment_request_batch_create_response import DeploymentRequestBatchCreateResponse
from ubiops.models.deployment_request_batch_detail import DeploymentRequestBatchDetail
from ubiops.models.deployment_request_create_response import DeploymentRequestCreateResponse
from ubiops.models.deployment_request_list import DeploymentRequestList
from ubiops.models.deployment_request_single_detail import DeploymentRequestSingleDetail
from ubiops.models.deployment_request_update import DeploymentRequestUpdate
from ubiops.models.deployment_request_update_response import DeploymentRequestUpdateResponse
from ubiops.models.deployment_update import DeploymentUpdate
from ubiops.models.deployment_version_create import DeploymentVersionCreate
from ubiops.models.deployment_version_detail import DeploymentVersionDetail
from ubiops.models.deployment_version_list import DeploymentVersionList
from ubiops.models.deployment_version_update import DeploymentVersionUpdate
from ubiops.models.direct_pipeline_request_deployment_request import DirectPipelineRequestDeploymentRequest
from ubiops.models.direct_pipeline_request_operator_request import DirectPipelineRequestOperatorRequest
from ubiops.models.environment_build_dependency import EnvironmentBuildDependency
from ubiops.models.environment_build_list import EnvironmentBuildList
from ubiops.models.environment_build_update import EnvironmentBuildUpdate
from ubiops.models.environment_create import EnvironmentCreate
from ubiops.models.environment_detail import EnvironmentDetail
from ubiops.models.environment_list import EnvironmentList
from ubiops.models.environment_revision_create import EnvironmentRevisionCreate
from ubiops.models.environment_revision_detail import EnvironmentRevisionDetail
from ubiops.models.environment_update import EnvironmentUpdate
from ubiops.models.environment_usage import EnvironmentUsage
from ubiops.models.environment_variable_copy import EnvironmentVariableCopy
from ubiops.models.environment_variable_create import EnvironmentVariableCreate
from ubiops.models.environment_variable_list import EnvironmentVariableList
from ubiops.models.export_create import ExportCreate
from ubiops.models.export_detail import ExportDetail
from ubiops.models.export_list import ExportList
from ubiops.models.expression_evaluate import ExpressionEvaluate
from ubiops.models.expression_evaluate_response import ExpressionEvaluateResponse
from ubiops.models.expression_input_field_create import ExpressionInputFieldCreate
from ubiops.models.file_detail import FileDetail
from ubiops.models.file_item import FileItem
from ubiops.models.file_upload_response import FileUploadResponse
from ubiops.models.import_detail import ImportDetail
from ubiops.models.import_list import ImportList
from ubiops.models.import_update import ImportUpdate
from ubiops.models.inherited_environment_variable_list import InheritedEnvironmentVariableList
from ubiops.models.input_field_widget_create import InputFieldWidgetCreate
from ubiops.models.input_output_field_detail import InputOutputFieldDetail
from ubiops.models.input_output_field_list import InputOutputFieldList
from ubiops.models.input_output_widget_list import InputOutputWidgetList
from ubiops.models.logs import Logs
from ubiops.models.logs_create import LogsCreate
from ubiops.models.metrics import Metrics
from ubiops.models.notification_group_contact import NotificationGroupContact
from ubiops.models.notification_group_create import NotificationGroupCreate
from ubiops.models.notification_group_list import NotificationGroupList
from ubiops.models.notification_group_update import NotificationGroupUpdate
from ubiops.models.operator_request_detail import OperatorRequestDetail
from ubiops.models.organization_create import OrganizationCreate
from ubiops.models.organization_detail import OrganizationDetail
from ubiops.models.organization_list import OrganizationList
from ubiops.models.organization_update import OrganizationUpdate
from ubiops.models.organization_user_create import OrganizationUserCreate
from ubiops.models.organization_user_detail import OrganizationUserDetail
from ubiops.models.organization_user_update import OrganizationUserUpdate
from ubiops.models.output_field_widget_create import OutputFieldWidgetCreate
from ubiops.models.permission_list import PermissionList
from ubiops.models.pipeline_create import PipelineCreate
from ubiops.models.pipeline_create_response import PipelineCreateResponse
from ubiops.models.pipeline_detail import PipelineDetail
from ubiops.models.pipeline_input_field_create import PipelineInputFieldCreate
from ubiops.models.pipeline_list import PipelineList
from ubiops.models.pipeline_output_field_create import PipelineOutputFieldCreate
from ubiops.models.pipeline_request_batch_create_response import PipelineRequestBatchCreateResponse
from ubiops.models.pipeline_request_create_response import PipelineRequestCreateResponse
from ubiops.models.pipeline_request_deployment_request import PipelineRequestDeploymentRequest
from ubiops.models.pipeline_request_detail import PipelineRequestDetail
from ubiops.models.pipeline_request_list import PipelineRequestList
from ubiops.models.pipeline_request_operator_request import PipelineRequestOperatorRequest
from ubiops.models.pipeline_request_single_detail import PipelineRequestSingleDetail
from ubiops.models.pipeline_update import PipelineUpdate
from ubiops.models.pipeline_version_create import PipelineVersionCreate
from ubiops.models.pipeline_version_detail import PipelineVersionDetail
from ubiops.models.pipeline_version_list import PipelineVersionList
from ubiops.models.pipeline_version_object_create import PipelineVersionObjectCreate
from ubiops.models.pipeline_version_object_list import PipelineVersionObjectList
from ubiops.models.pipeline_version_update import PipelineVersionUpdate
from ubiops.models.project_create import ProjectCreate
from ubiops.models.project_detail import ProjectDetail
from ubiops.models.project_list import ProjectList
from ubiops.models.project_resource_usage import ProjectResourceUsage
from ubiops.models.project_update import ProjectUpdate
from ubiops.models.project_user_create import ProjectUserCreate
from ubiops.models.project_user_list import ProjectUserList
from ubiops.models.quota_detail import QuotaDetail
from ubiops.models.requests_overview import RequestsOverview
from ubiops.models.resource_usage import ResourceUsage
from ubiops.models.revision_create import RevisionCreate
from ubiops.models.revision_list import RevisionList
from ubiops.models.role_assignment_create import RoleAssignmentCreate
from ubiops.models.role_assignment_list import RoleAssignmentList
from ubiops.models.role_create import RoleCreate
from ubiops.models.role_detail_list import RoleDetailList
from ubiops.models.role_list import RoleList
from ubiops.models.role_update import RoleUpdate
from ubiops.models.schedule_create import ScheduleCreate
from ubiops.models.schedule_list import ScheduleList
from ubiops.models.schedule_update import ScheduleUpdate
from ubiops.models.service_user_create import ServiceUserCreate
from ubiops.models.service_user_list import ServiceUserList
from ubiops.models.service_user_token_detail import ServiceUserTokenDetail
from ubiops.models.service_user_token_list import ServiceUserTokenList
from ubiops.models.status import Status
from ubiops.models.template_deployment_list import TemplateDeploymentList
from ubiops.models.usage import Usage
from ubiops.models.usage_metric import UsageMetric
from ubiops.models.user_pending_create import UserPendingCreate
from ubiops.models.user_pending_detail import UserPendingDetail


# import utils
import ubiops.utils
