# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.  # noqa: E501

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubiops.configuration import Configuration


class BucketCreate(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'provider': 'str',
        'credentials': 'dict(str, str)',
        'configuration': 'dict(str, str)',
        'ttl': 'int',
        'description': 'str',
        'labels': 'dict(str, str)'
    }

    attribute_map = {
        'name': 'name',
        'provider': 'provider',
        'credentials': 'credentials',
        'configuration': 'configuration',
        'ttl': 'ttl',
        'description': 'description',
        'labels': 'labels'
    }

    def __init__(self, name=None, provider=None, credentials=None, configuration=None, ttl=None, description=None, labels=None, local_vars_configuration=None, **kwargs):  # noqa: E501
        """BucketCreate - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._provider = None
        self._credentials = None
        self._configuration = None
        self._ttl = None
        self._description = None
        self._labels = None
        self.discriminator = None

        self.name = name
        self.provider = provider
        self.credentials = credentials
        self.configuration = configuration
        self.ttl = ttl
        if description is not None:
            self.description = description
        if labels is not None:
            self.labels = labels

    @property
    def name(self):
        """Gets the name of this BucketCreate.  # noqa: E501


        :return: The name of this BucketCreate.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BucketCreate.


        :param name: The name of this BucketCreate.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if self.local_vars_configuration.client_side_validation and (
            name is not None and not isinstance(name, str)
        ):
            raise ValueError("Parameter `name` must be a string")  # noqa: E501

        if self.local_vars_configuration.client_side_validation and (
            name is not None and len(name) < 1
        ):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def provider(self):
        """Gets the provider of this BucketCreate.  # noqa: E501


        :return: The provider of this BucketCreate.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this BucketCreate.


        :param provider: The provider of this BucketCreate.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and provider is None:  # noqa: E501
            raise ValueError("Invalid value for `provider`, must not be `None`")  # noqa: E501
        if self.local_vars_configuration.client_side_validation and (
            provider is not None and not isinstance(provider, str)
        ):
            raise ValueError("Parameter `provider` must be a string")  # noqa: E501
        allowed_values = ["ubiops", "google_cloud_storage", "amazon_s3", "azure_blob_storage"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and provider not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `provider` ({0}), must be one of {1}"  # noqa: E501
                .format(provider, allowed_values)
            )

        self._provider = provider

    @property
    def credentials(self):
        """Gets the credentials of this BucketCreate.  # noqa: E501


        :return: The credentials of this BucketCreate.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._credentials

    @credentials.setter
    def credentials(self, credentials):
        """Sets the credentials of this BucketCreate.


        :param credentials: The credentials of this BucketCreate.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and (
            credentials is not None and not isinstance(credentials, dict)
        ):
            raise ValueError("Parameter `credentials` must be a dictionary")  # noqa: E501

        self._credentials = credentials

    @property
    def configuration(self):
        """Gets the configuration of this BucketCreate.  # noqa: E501


        :return: The configuration of this BucketCreate.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this BucketCreate.


        :param configuration: The configuration of this BucketCreate.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and (
            configuration is not None and not isinstance(configuration, dict)
        ):
            raise ValueError("Parameter `configuration` must be a dictionary")  # noqa: E501

        self._configuration = configuration

    @property
    def ttl(self):
        """Gets the ttl of this BucketCreate.  # noqa: E501


        :return: The ttl of this BucketCreate.  # noqa: E501
        :rtype: int
        """
        return self._ttl

    @ttl.setter
    def ttl(self, ttl):
        """Sets the ttl of this BucketCreate.


        :param ttl: The ttl of this BucketCreate.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and (
            ttl is not None and not isinstance(ttl, int)
        ):
            raise ValueError("Parameter `ttl` must be an integer")  # noqa: E501

        self._ttl = ttl

    @property
    def description(self):
        """Gets the description of this BucketCreate.  # noqa: E501


        :return: The description of this BucketCreate.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this BucketCreate.


        :param description: The description of this BucketCreate.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and (
            description is not None and not isinstance(description, str)
        ):
            raise ValueError("Parameter `description` must be a string")  # noqa: E501

        self._description = description

    @property
    def labels(self):
        """Gets the labels of this BucketCreate.  # noqa: E501


        :return: The labels of this BucketCreate.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this BucketCreate.


        :param labels: The labels of this BucketCreate.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and (
            labels is not None and not isinstance(labels, dict)
        ):
            raise ValueError("Parameter `labels` must be a dictionary")  # noqa: E501

        self._labels = labels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BucketCreate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BucketCreate):
            return True

        return self.to_dict() != other.to_dict()
